;;; 50ddskk.el --- Debian ddskk startup file  -*-mode: emacs-lisp;-*-

;;; Code:

(let ((lispdir (concat "/usr/share/" (symbol-name flavor) "/site-lisp/ddskk")))
  (when (and (featurep 'mule) (file-exists-p (concat lispdir "/skk.elc")))
    (if (fboundp 'debian-pkg-add-load-path-item)
	(debian-pkg-add-load-path-item lispdir)
      (setq load-path (cons lispdir load-path)))
    ;; Load ddskk's skk-autoloads instead of the others.
    (load (concat lispdir "/skk-autoloads.elc") 'noerror 'nomessage)
    (require 'skk-setup)
    (add-hook 'minibuffer-setup-hook
	      (function (lambda ()
			  (and (boundp 'skk-henkan-okuri-strictly)
			       skk-henkan-okuri-strictly
			       (not (eq last-command 'skk-purge-jisyo))
			       (put 'skk-henkan-okuri-strictly 'temporary-nil t)
			       (setq skk-henkan-okuri-strictly nil)))))
    (add-hook 'minibuffer-exit-hook
	      (function (lambda ()
			  (and (get 'skk-henkan-okuri-strictly 'temporary-nil)
			       (setq skk-henkan-okuri-strictly t)
			       (put 'skk-henkan-okuri-strictly 'temporary-nil nil)))))
    (setq skk-server-host (or (getenv "SKKSERVER") "localhost"))
    (if (file-exists-p "/usr/share/skk/SKK-JISYO")
	(setq skk-aux-large-jisyo "/usr/share/skk/SKK-JISYO"))
    (setq skk-tut-file "/usr/share/skk/SKK.tut")
    (if (boundp 'data-directory-list)
	(add-to-list 'data-directory-list "/usr/share/skk"))
    (setq skk-e21-coding-system nil)
    ;;
    ))

;;; 50ddskk.el ends here
